## amarok 3.3.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(Amarok)

###############

set(KF_MIN_VERSION "6.0.0")
set(KF_MAJOR_VERSION "6")
set(QT_MIN_VERSION "6.7.0")
set(QT_MAJOR_VERSION "6")

find_package(PkgConfig REQUIRED)
find_package(ECM ${KF_MIN_VERSION} REQUIRED CONFIG)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake/modules ${CMAKE_MODULE_PATH} ${ECM_MODULE_PATH})

include(KDEInstallDirs)
include(KDECMakeSettings)
#include(KDEFrameworkCompilerSettings NO_POLICY_SCOPE)
include(KDECompilerSettings NO_POLICY_SCOPE)
include(FeatureSummary)
include(ECMInstallIcons)
include(ECMSetupVersion)
include(ECMAddTests)
include(ECMAddAppIcon)
include(ECMPoQmTools)
include(FindPkgConfig)
include(CMakePushCheckState)
include(GenerateExportHeader)
include(CheckIncludeFile)

find_package(Qt${QT_MAJOR_VERSION} ${QT_MIN_VERSION} REQUIRED COMPONENTS Core DBus Gui QuickWidgets Qml Sql Svg Test Widgets Xml)

find_package(Qt${QT_MAJOR_VERSION}QuickControls2 ${QT_MIN_VERSION})
set_package_properties(Qt${QT_MAJOR_VERSION}QuickControls2 PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")


find_package(Qt${QT_MAJOR_VERSION}SvgWidgets ${QT_MIN_VERSION} REQUIRED)
find_package(Qt${QT_MAJOR_VERSION}WebEngineWidgets ${QT_MIN_VERSION})
set_package_properties(Qt${QT_MAJOR_VERSION}WebEngineWidgets PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the wikipedia applet")

find_package(Qt${QT_MAJOR_VERSION}UiTools ${QT_MIN_VERSION})
set_package_properties(Qt${QT_MAJOR_VERSION}UiTools PROPERTIES TYPE OPTIONAL PURPOSE "Needed by the scripting engine")

find_package(KF${KF_MAJOR_VERSION} ${KF_MIN_VERSION} REQUIRED COMPONENTS
    Archive
    Codecs
    Config
    ConfigWidgets
    CoreAddons
    Crash
    DBusAddons
    DNSSD
    DocTools
    GlobalAccel
    GuiAddons
    I18n
    IconThemes
    KCMUtils
    KIO
    Notifications
    Package
    Solid
    TextEditor
    TextWidgets
    ThreadWeaver
    WidgetsAddons
    WindowSystem
)

find_package(KF${KF_MAJOR_VERSION}ColorScheme ${KF_MIN_VERSION} REQUIRED)
find_package(KF${KF_MAJOR_VERSION}KCMUtils ${KF_MIN_VERSION} REQUIRED)
find_package(KF${KF_MAJOR_VERSION}StatusNotifierItem ${KF_MIN_VERSION} REQUIRED)
find_package(KF${KF_MAJOR_VERSION}Kirigami ${KF_MIN_VERSION})
set_package_properties(KF${KF_MAJOR_VERSION}Kirigami PROPERTIES TYPE RUNTIME PURPOSE "Needed by the player's context area")

pkg_check_modules(GSTREAMER REQUIRED gstreamer-1.0>=1.10)
set_package_properties( GSTREAMER PROPERTIES DESCRIPTION "GStreamer is required for the audio backend" URL "https://gstreamer.freedesktop.org/" TYPE REQUIRED )

pkg_check_modules(GSTREAMER_AUDIO REQUIRED gstreamer-audio-1.0>=1.10)
set_package_properties( GSTREAMER_AUDIO PROPERTIES DESCRIPTION "GStreamer is required for the audio backend" URL "https://gstreamer.freedesktop.org/" TYPE REQUIRED )

pkg_check_modules(GSTREAMER_PLUGINS_BASE REQUIRED gstreamer-plugins-base-1.0>=1.10)
set_package_properties( GSTREAMER_PLUGINS_BASE PROPERTIES DESCRIPTION "GStreamer base plugins are required for the audio backend" URL "https://gstreamer.freedesktop.org/" TYPE REQUIRED )

set(CMAKE_REQUIRED_INCLUDES "${GSTREAMER_INCLUDE_DIRS}")
check_include_file(gst/gst.h HAVE_GST_H)
if(GSTREAMER_FOUND)
    message(STATUS "Found GStreamer: ${GSTREAMER_LIBRARIES}")
endif()
if(NOT HAVE_GST_H)
    message(FATAL_ERROR "Missing GStreamer headers - please install devel packages" )
endif()

pkg_search_module(GLIB REQUIRED glib-2.0)
set_package_properties( GLIB2 PROPERTIES DESCRIPTION "GLib 2 is required to compile the gstreamer audio backend" URL "https://www.gtk.org" TYPE REQUIRED )

pkg_search_module( GOBJECT REQUIRED gobject-2.0 )
set_package_properties( GOBJECT PROPERTIES DESCRIPTION "GObject is required to compile the gstreamer audio backend" URL "https://www.gtk.org" TYPE OPTIONAL )

###############
if(UNIX AND NOT APPLE AND NOT ANDROID AND NOT HAIKU)
  option(WITH_X11 "Build with X11 integration" ON)
endif()
option(WITH_UTILITIES "Enable building of utilities" ON)
option(WITH_PLAYER "Enable building of main Amarok player" ON)
# option(WITH_MP3Tunes "Enable mp3tunes in the Amarok player, requires multiple extra dependencies" ON) #build is disabled for now, no need to show option
option(WITH_GPODDER "Enable gpodder.net support" ON)
option(WITH_IPOD "Enable iPod support in Amarok" ON)
option(WITH_LASTFM "Enable last.fm support" ON)
option(WITH_EMBEDDED_DB "Build the embedded database library" ON)

############### Taglib
set(TAGLIB_MIN_VERSION "1.12")
find_package(Taglib REQUIRED)
set_package_properties( Taglib PROPERTIES DESCRIPTION "Support for Audio metadata." URL "https://taglib.org/" TYPE REQUIRED PURPOSE "Required for tag reading" )

# Check if TagLib is built with ASF and MP4 support
include(CheckCXXSourceCompiles)
cmake_push_check_state()
set(CMAKE_REQUIRED_INCLUDES "${TAGLIB_INCLUDES}")
set(CMAKE_REQUIRED_LIBRARIES "${TAGLIB_LIBRARIES}")

check_cxx_source_compiles("#include <asftag.h>
int main() { TagLib::ASF::Tag tag; return 0;}" TAGLIB_ASF_FOUND)
if( NOT TAGLIB_ASF_FOUND )
    message(FATAL_ERROR "TagLib does not have ASF support compiled in.")
endif()

check_cxx_source_compiles("#include <mp4tag.h>
int main() { TagLib::MP4::Tag tag(0, 0); return 0;}" TAGLIB_MP4_FOUND)
if( NOT TAGLIB_MP4_FOUND )
    message(FATAL_ERROR "TagLib does not have MP4 support compiled in.")
endif()

check_cxx_source_compiles("#include <modtag.h>
#include <modfile.h>
#include <s3mfile.h>
#include <itfile.h>
#include <xmfile.h>
using namespace TagLib;
int main() { char *s; Mod::Tag tag; Mod::File modfile(s); S3M::File s3mfile(s);
IT::File itfile(s); XM::File xmfile(s); return 0; }" TAGLIB_MOD_FOUND)

check_cxx_source_compiles("#include <opusfile.h>
int main() { char *s; TagLib::Ogg::Opus::File opusfile(s); return 0;}" TAGLIB_OPUS_FOUND)
cmake_pop_check_state()

include(CheckTagLibFileName)

check_taglib_filename(COMPLEX_TAGLIB_FILENAME)
###############


#Needed to conditionally build tests and gui
find_package(Googlemock)
set_package_properties( GOOGLEMOCK PROPERTIES DESCRIPTION "Used in Amarok's tests." URL "https://github.com/google/googlemock" TYPE OPTIONAL )

if(NOT GOOGLEMOCK_FOUND)
    set(BUILD_TESTING OFF)
endif()

if(BUILD_TESTING)
   add_definitions(-DDEBUG)
endif()

if(WITH_DESKTOP_UI)
    add_definitions(-DDESKTOP_UI)
endif()
set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fmessage-length=0")
if (CMAKE_COMPILER_IS_GNUCXX)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fmessage-length=0")
    if(${CMAKE_SYSTEM_NAME} MATCHES "Linux")
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wl,--as-needed")
    endif()
endif ()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}/shared
    ${CMAKE_CURRENT_BINARY_DIR}/shared
)

set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

# WORKAROUND for Clang bug: http://llvm.org/bugs/show_bug.cgi?id=15651
if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang" AND WIN32)
    set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fno-delayed-template-parsing")
endif ()

####################################################################################
# CMAKE_AUTOMOC

if(NOT CMAKE_VERSION VERSION_LESS "3.10.0")
    # CMake 3.9+ warns about automoc on files without Q_OBJECT, and doesn't know about other macros.
    # 3.10+ lets us provide more macro names that require automoc.
    list(APPEND CMAKE_AUTOMOC_MACRO_NAMES AMAROK_EXPORT_SIMPLE_IMPORTER_PLUGIN)
endif()

add_definitions(-DQT_NO_URL_CAST_FROM_STRING -DQT_NO_CAST_TO_ASCII)

if( WITH_LASTFM )
    find_package( LibLastFm 1.2.0 )
    set( LIBLASTFM_MIN_VERSION "1.2.0" )
    if( LIBLASTFM_FOUND )
        if ( ${LIBLASTFM_MIN_VERSION} VERSION_LESS ${LIBLASTFM_VERSION} )
            set( LIBLASTFM_FOUND TRUE )
        endif()
    endif()
endif()

string( TOLOWER "${CMAKE_BUILD_TYPE}" CMAKE_BUILD_TYPE_TOLOWER )
if( CMAKE_BUILD_TYPE_TOLOWER MATCHES debug )
    set( DEBUG_BUILD_TYPE ON )
    if (MSVC)
        add_compile_options(/W4 /WX)
    else()
        add_definitions(-Wall -Wextra)
    endif()
endif()

add_subdirectory( data )
add_subdirectory( images )

if( WITH_PLAYER )
    find_package(Threads REQUIRED)

    find_package(MySQL)

    if( NOT MySQL_FOUND )
        find_package(MariaDB REQUIRED)
    endif()

    if( WITH_EMBEDDED_DB )
        find_package(MariaDBd REQUIRED)
        set( BUILD_MYSQLE_COLLECTION TRUE )
        # zlib is required for mysql embedded
        find_package(ZLIB REQUIRED)
        set_package_properties( ZLIB PROPERTIES DESCRIPTION "zlib" TYPE REQUIRED )
    else()
        add_definitions( "-DNO_MYSQL_EMBEDDED" )
        message("Building without embedded MariaDB/MySQL as requested")
    endif()


    # Qt6 support is currently only available in liblastfm forks
    set( LIBLASTFM_MIN_VERSION "1.2.0" )
    set_package_properties( LibLastFm PROPERTIES DESCRIPTION "Enable Last.Fm service, including scrobbling, song submissions, and suggested song dynamic playlists" URL "https://github.com/Mazhoon/liblastfm/" TYPE OPTIONAL )


    if( WITH_GPODDER )
        ## gpodder Service
        find_package(Mygpo-qt6 1.2.0 CONFIG)
        set_package_properties(Mygpo-qt6 PROPERTIES
            DESCRIPTION "A Qt/C++ library wrapping the gpodder.net Webservice."
            URL "http://wiki.gpodder.org/wiki/Libmygpo-qt"
            TYPE OPTIONAL
            PURPOSE "Synchronize podcast subscriptions with gpodder.net"
        )
    endif()

    if( WITH_IPOD )
        find_package(Ipod)
        set(IPOD_MIN_VERSION "0.8.2")
        if( IPOD_FOUND AND NOT WIN32 )
            if ( ${IPOD_MIN_VERSION} VERSION_LESS ${IPOD_VERSION} )
                set( IPOD_FOUND TRUE )
            endif()
        endif()
        set_package_properties( Ipod PROPERTIES DESCRIPTION "Support Apple iPod/iPad/iPhone audio devices" URL "http://sourceforge.net/projects/gtkpod/" TYPE OPTIONAL )
        find_package(GDKPixBuf)
        set_package_properties( GDKPixBuf PROPERTIES DESCRIPTION "Support for artwork on iPod audio devices via GDK-PixBuf" URL "http://developer.gnome.org/arch/imaging/gdkpixbuf.html" TYPE OPTIONAL )
    endif()

    find_package(Mtp 1.0.0)
    set_package_properties(Mtp PROPERTIES
        TYPE OPTIONAL
        PURPOSE "Enable Support for portable media devices that use the media transfer protocol"
    )

    if( WITH_MP3Tunes )
        find_package(CURL)
        set_package_properties( CURL PROPERTIES DESCRIPTION "Used to transfer data with URLs" URL "https://curl.haxx.se/" TYPE OPTIONAL )

        find_package(LibXml2)
        set_package_properties( LibXml2 PROPERTIES DESCRIPTION "LibXML2 is an XML parser required by mp3tunes." URL "http://www.xmlsoft.org" TYPE OPTIONAL )

        find_package(OpenSSL)
        find_package(Libgcrypt)
        if ( OPENSSL_FOUND OR LIBGCRYPT_FOUND )
            set (_mp3tunes_crypto TRUE )
        else ()
            message( SEND_ERROR "Building with mp3tunes support REQUIRES either OpenSSL or GNU Libgcrypt" )
        endif ()
        set_package_properties( OpenSSL PROPERTIES DESCRIPTION "OpenSSL or GNU Libgcrypt provides cryptographic functions required by mp3tunes." URL "http://www.openssl.org/ or http://www.gnupg.org/download/#libgcrypt" TYPE OPTIONAL )
        set_package_properties( Libgcrypt PROPERTIES DESCRIPTION "OpenSSL or GNU Libgcrypt provides cryptographic functions required by mp3tunes." URL "http://www.openssl.org/ or http://www.gnupg.org/download/#libgcrypt" TYPE OPTIONAL )

        find_package(Loudmouth)
        set_package_properties( Loudmouth PROPERTIES DESCRIPTION "Loudmouth is the communication backend needed by mp3tunes for syncing." URL "http://www.loudmouth-project.org" TYPE OPTIONAL )

        include(CheckQtGlib)
        set_package_properties( QT5_GLIB PROPERTIES DESCRIPTION "Qt5 must be compiled with glib support for mp3tunes" URL "http://www.trolltech.com" TYPE OPTIONAL )
    endif()

    find_package(Python3 COMPONENTS Interpreter)
    set_package_properties(Python3 PROPERTIES
        DESCRIPTION "Required for generating the autocompletion file for the script console"
        URL "https://www.python.org"

=== shared/CMakeLists.txt ===
set( amarokshared_SRCS
    FileType.cpp
    FileTypeResolver.cpp
    MetaReplayGain.cpp
    MetaTagLib.cpp
    TagsFromFileNameGuesser.cpp
)

set( amarokshared_collectionscanner_SRCS
    collectionscanner/Album.cpp
    collectionscanner/BatchFile.cpp
    collectionscanner/Directory.cpp
    collectionscanner/Playlist.cpp
    collectionscanner/ScanningState.cpp
    collectionscanner/Track.cpp
)


set( amarokshared_tag_helpers_SRCS
    tag_helpers/APETagHelper.cpp
    tag_helpers/ASFTagHelper.cpp
    tag_helpers/ID3v2TagHelper.cpp
    tag_helpers/MP4TagHelper.cpp
    tag_helpers/StringHelper.cpp
    tag_helpers/TagHelper.cpp
    tag_helpers/VorbisCommentTagHelper.cpp
)

add_library( amarokshared SHARED
    ${amarokshared_SRCS}
    ${amarokshared_collectionscanner_SRCS}
    ${amarokshared_tag_helpers_SRCS} )

generate_export_header(amarokshared BASE_NAME amarokshared)


target_include_directories( amarokshared PUBLIC ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR} )

include_directories(SYSTEM ${TAGLIB_INCLUDES} )
add_definitions( ${TAGLIB_CFLAGS} )
target_link_libraries( amarokshared ${TAGLIB_LIBRARIES} KF${KF_MAJOR_VERSION}::Codecs)

target_link_libraries( amarokshared
  Qt::Core
  Qt::Gui # for QImage, ...
)

set_target_properties( amarokshared PROPERTIES VERSION 1.0.0 SOVERSION 1 )
install( TARGETS amarokshared ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )

=== src/CMakeLists.txt ===
# Improves speed of string concatenation
add_definitions(-DQT_USE_FAST_CONCATENATION)
add_definitions(-DQT_USE_FAST_OPERATOR_PLUS)

if(APPLE)
    set(mac_SRCS
        app_mac.cpp
        mac/GrowlInterface.cpp
    )
    # Notification Center Appeared in 10.8, or Darwin 12
    if( CMAKE_SYSTEM_VERSION VERSION_GREATER "11.9.9")
        list(APPEND mac_SRCS mac/MacSystemNotify.mm)
        add_definitions(-DHAVE_NOTIFICATION_CENTER)
    endif()

    include_directories ( services/lastfm/ )
    set( MAC_FILES_DIR  ${CMAKE_SOURCE_DIR}/src/mac )
endif()

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/core-impl/collections/db/sql/
)

include_directories(SYSTEM
    ${GSTREAMER_INCLUDE_DIRS}
    ${GSTREAMER_AUDIO_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
)

add_subdirectory( core )
add_subdirectory( core-impl/collections )
add_subdirectory( core-impl/storage/sql )
add_subdirectory( context )
add_subdirectory( services )
add_subdirectory( scripting/scripts )
add_subdirectory( transcoding )
add_subdirectory( importers )

#####################################################################
# PROXYCOLLECTION
#####################################################################
set(aggregatecollection_SRCS
    core-impl/collections/aggregate/AggregateCollection.cpp
    core-impl/collections/aggregate/AggregateMeta.cpp
    core-impl/collections/aggregate/AggregateQueryMaker.cpp
)

#####################################################################
# MEDIADEVICEFRAMEWORK
#####################################################################
set(libmediadeviceframework_SRCS
  core-impl/collections/mediadevicecollection/MediaDeviceCollection.cpp
  core-impl/collections/mediadevicecollection/MediaDeviceCollectionLocation.cpp
  core-impl/collections/mediadevicecollection/MediaDeviceMeta.cpp
  core-impl/collections/mediadevicecollection/MediaDeviceTrackEditor.cpp
  core-impl/collections/mediadevicecollection/handler/MediaDeviceHandler.cpp
  core-impl/collections/mediadevicecollection/handler/MediaDeviceHandlerCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/ArtworkCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/PlaylistCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/PodcastCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/ReadCapability.cpp
  core-impl/collections/mediadevicecollection/handler/capabilities/WriteCapability.cpp
  core-impl/collections/mediadevicecollection/playlist/MediaDevicePlaylist.cpp
  core-impl/collections/mediadevicecollection/playlist/MediaDeviceUserPlaylistProvider.cpp
  core-impl/collections/mediadevicecollection/podcast/MediaDevicePodcastProvider.cpp
  core-impl/collections/mediadevicecollection/support/ConnectionAssistant.cpp
  core-impl/collections/mediadevicecollection/support/MediaDeviceInfo.cpp
)

#####################################################################
# SERVICEFRAMEWORK
#####################################################################
set(libserviceframework_SRCS
    services/DynamicServiceQueryMaker.cpp
    services/InfoParserBase.cpp
    services/ServiceAlbumCoverDownloader.cpp
    services/ServiceBase.cpp
    services/ServiceCapabilities.cpp
    services/ServiceCollection.cpp
    services/ServiceCollectionLocation.cpp
    services/ServiceCollectionTreeView.cpp
    services/ServiceMetaBase.cpp
    services/ServicePluginManager.cpp
    services/ServiceSqlCollection.cpp
    services/ServiceSqlQueryMaker.cpp
    services/ServiceSqlRegistry.cpp
)

#####################################################################
# SERVICEBROWSER
#####################################################################
set(libservicebrowser_SRCS
    browsers/servicebrowser/ServiceBrowser.cpp
)

#####################################################################
# AMAROKURL
#####################################################################
set(libamarokurl_SRCS
    amarokurls/AmarokUrl.cpp
    amarokurls/AmarokUrlAction.cpp
    amarokurls/AmarokUrlHandler.cpp
    amarokurls/BookmarkCurrentButton.cpp
    amarokurls/ContextUrlGenerator.cpp
    amarokurls/ContextUrlRunner.cpp
    amarokurls/NavigationUrlRunner.cpp
    amarokurls/NavigationUrlGenerator.cpp
    amarokurls/PlayUrlRunner.cpp
    amarokurls/PlayUrlGenerator.cpp
    amarokurls/BookmarkManager.cpp
    amarokurls/BookmarkManagerWidget.cpp
    amarokurls/BookmarkGroup.cpp
    amarokurls/BookmarkModel.cpp
    amarokurls/BookmarkTreeView.cpp
    amarokurls/BookmarkMetaActions.cpp
    )

#####################################################################
# SCRIPTABLESERVICE
#####################################################################
set(libscriptableservice_SRCS
    services/scriptable/ScriptableService.cpp
    services/scriptable/ScriptableServiceCollection.cpp
    services/scriptable/ScriptableServiceCollectionTreeModel.cpp
    services/scriptable/ScriptableServiceInfoParser.cpp
    services/scriptable/ScriptableServiceManager.cpp
    services/scriptable/ScriptableServiceMeta.cpp
    services/scriptable/ScriptableServiceQueryMaker.cpp
)

#####################################################################
# CONFIGDIALOG
#####################################################################
set(libconfigdialog_SRCS
    configdialog/ConfigDialog.cpp
    configdialog/ConfigDialogBase.cpp
    configdialog/dialogs/CollectionConfig.cpp
    configdialog/dialogs/ExcludedLabelsDialog.cpp
    configdialog/dialogs/GeneralConfig.cpp
    configdialog/dialogs/MetadataConfig.cpp
    configdialog/dialogs/NotificationsConfig.cpp
    configdialog/dialogs/PlaybackConfig.cpp
    configdialog/dialogs/PluginsConfig.cpp
    configdialog/dialogs/ScriptsConfig.cpp
    configdialog/dialogs/ScriptSelector.cpp
    configdialog/dialogs/DatabaseConfig.cpp
)

ki18n_wrap_ui(libconfigdialog_SRCS
    configdialog/dialogs/CollectionConfig.ui
    configdialog/dialogs/GeneralConfig.ui
    configdialog/dialogs/MetadataConfig.ui
    configdialog/dialogs/ExcludedLabelsDialog.ui
    configdialog/dialogs/NotificationsConfig.ui
    configdialog/dialogs/PlaybackConfig.ui
    configdialog/dialogs/DatabaseConfig.ui
    configdialog/dialogs/ScriptsConfig.ui
)

set(libbrowserframework_SRCS
    browsers/BrowserBreadcrumbItem.cpp
    browsers/BrowserBreadcrumbWidget.cpp
    browsers/BrowserCategory.cpp
    browsers/BrowserCategoryList.cpp
    browsers/BrowserCategoryListModel.cpp
    browsers/BrowserCategoryListSortFilterProxyModel.cpp
    browsers/BrowserDock.cpp
    browsers/BrowserMessageArea.cpp
    browsers/CollectionSortFilterProxyModel.cpp
    browsers/CollectionTreeItem.cpp
    browsers/CollectionTreeItemModel.cpp
    browsers/CollectionTreeItemModelBase.cpp
    browsers/CollectionTreeView.cpp
    browsers/InfoProxy.cpp
    browsers/SingleCollectionTreeItemModel.cpp
)

#####################################################################
# COLLECTIONBROWSER
#####################################################################
set(libcollectionbrowser_SRCS
    browsers/collectionbrowser/CollectionBrowserTreeView.cpp
    browsers/collectionbrowser/CollectionWidget.cpp
)

#####################################################################
# SYNCHRONIZATION
#####################################################################
set(libsynchronization_SRCS
    synchronization/MasterSlaveSynchronizationJob.cpp
    synchronization/OneWaySynchronizationJob.cpp
    synchronization/SynchronizationBaseJob.cpp
    synchronization/UnionJob.cpp
)

#####################################################################
# STATUSBAR
#####################################################################
set(libstatusbar_SRCS
    statusbar/ProgressBar.cpp
    statusbar/KJobProgressBar.cpp
    statusbar/NetworkProgressBar.cpp
    statusbar/CompoundProgressBar.cpp
    statusbar/PopupWidget.cpp
    statusbar/LongMessageWidget.cpp
)


#####################################################################
# META
#####################################################################
set(libmetaimpl_SRCS
    core-impl/playlists/providers/user/UserPlaylistProvider.cpp
    core-impl/playlists/types/file/asx/ASXPlaylist.cpp
    core-impl/playlists/types/file/m3u/M3UPlaylist.cpp
    core-impl/playlists/types/file/pls/PLSPlaylist.cpp
    core-impl/playlists/types/file/PlaylistFileLoaderJob.cpp
    core-impl/playlists/types/file/PlaylistFileSupport.cpp
    core-impl/playlists/types/file/xspf/XSPFPlaylist.cpp
    core-impl/capabilities/AlbumActionsCapability.cpp
    core-impl/capabilities/timecode/TimecodeBoundedPlaybackCapability.cpp
    core-impl/capabilities/timecode/TimecodeLoadCapability.cpp
    core-impl/capabilities/timecode/TimecodeWriteCapability.cpp
    core-impl/capabilities/multisource/MultiSourceCapabilityImpl.cpp
    core-impl/meta/file/File.cpp
    core-impl/meta/file/FileTrackProvider.cpp
    core-impl/meta/multi/MultiTrack.cpp
    core-impl/meta/cue/CueFileSupport.cpp
    core-impl/meta/proxy/MetaProxy.cpp
    core-impl/meta/proxy/MetaProxyWorker.cpp
    core-impl/meta/stream/Stream.cpp
    core-impl/playlists/types/file/PlaylistFile.cpp
    core-impl/support/PersistentStatisticsStore.cpp
    core-impl/support/TagStatisticsStore.cpp
    core-impl/support/UrlStatisticsStore.cpp
)

#####################################################################
# COLLECTION
#####################################################################
set(collection_SRCS
    core-impl/collections/support/jobs/WriteTagsJob.cpp
    core-impl/collections/support/ArtistHelper.cpp
    core-impl/collections/support/CollectionManager.cpp
    core-impl/collections/support/CollectionLocationDelegateImpl.cpp
    core-impl/collections/support/MemoryCustomValue.cpp
    core-impl/collections/support/MemoryFilter.cpp
    core-impl/collections/support/MemoryMatcher.cpp
    core-impl/collections/support/MemoryMeta.cpp
    core-impl/collections/support/MemoryQueryMaker.cpp
    core-impl/collections/support/MemoryQueryMakerInternal.cpp
    core-impl/collections/support/MemoryQueryMakerHelper.cpp
    core-impl/collections/support/TrashCollectionLocation.cpp
    core-impl/collections/support/XmlQueryReader.cpp
    core-impl/collections/support/FileCollectionLocation.cpp
    core-impl/collections/support/Expression.cpp
    core-impl/collections/support/TextualQueryFilter.cpp
)

#####################################################################
# STORAGE
#####################################################################
set(storage_SRCS
    core-impl/storage/StorageManager.cpp
)

#####################################################################
# SCANNER
#####################################################################
set( scanner_SRCS
    scanner/GenericScanManager.cpp
    scanner/GenericScannerJob.cpp
    scanner/AbstractDirectoryWatcher.cpp
    scanner/AbstractScanResultProcessor.cpp
)

#####################################################################
# CONTEXT
#####################################################################
set( libcontextview_SRCS
    context/AmarokContextPackageStructure.cpp
    context/AppletLoader.cpp
    context/AppletModel.cpp
    context/ContextDock.cpp
    context/ContextView.cpp
)

#####################################################################
# LYRICS
#####################################################################
set( liblyrics_SRCS
    lyrics/LyricsManager.cpp
)

#####################################################################
# PODCASTS
#####################################################################
set(libpodcasts_SRCS
    core-impl/podcasts/sql/SqlPodcastMeta.cpp
    core-impl/podcasts/sql/SqlPodcastProvider.cpp
    core-impl/podcasts/sql/PodcastSettingsDialog.cpp
    core-impl/podcasts/sql/PodcastFilenameLayoutConfigDialog.cpp
)

#####################################################################

=== tests/CMakeLists.txt ===
set( EXECUTABLE_OUTPUT_PATH ${CMAKE_CURRENT_BINARY_DIR} )

set( AMAROK_SOURCE_TREE ${CMAKE_SOURCE_DIR}/src )
set( AMAROK_TEST_TREE ${CMAKE_SOURCE_DIR}/tests )
set( AMAROK_UTILITY_TREE ${CMAKE_SOURCE_DIR}/utilities )
set( AMAROK_UTILITIES_DIR ${CMAKE_BINARY_DIR}/bin )
set( STRESS_TEST_TRACK_COUNT 20000 )

configure_file(config-amarok-test.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/config-amarok-test.h )

include_directories(
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}
    ${CMAKE_SOURCE_DIR}/src
    ${CMAKE_BINARY_DIR}/src
)
include_directories(SYSTEM
    ${GOOGLEMOCK_INCLUDE_DIR} )

include_directories(SYSTEM
    ${GSTREAMER_INCLUDE_DIRS}
    ${GSTREAMER_AUDIO_INCLUDE_DIRS}
    ${GLIB_INCLUDE_DIRS}
)

if( LIBLASTFM_FOUND ) # needed by Last.fm error handler in App.cpp
    include_directories(SYSTEM ${LIBLASTFM_INCLUDE_DIR})
endif()

add_subdirectory( amarokurls )
add_subdirectory( browsers )
add_subdirectory( context )
add_subdirectory( core )
add_subdirectory( core-impl )
add_subdirectory( dynamic )
if( ${CMAKE_SYSTEM_NAME} MATCHES "Linux" )
add_subdirectory( importers )
endif()
add_subdirectory( playlist )
add_subdirectory( playlistmanager )
add_subdirectory( timecode )
add_subdirectory( scanner )
add_subdirectory( synchronization )

#------------------------ Test Amarok namespace -----------------------------

set( testamarok_SRCS
        TestAmarok.cpp
        ${AMAROK_SOURCE_TREE}/core/support/Amarok.cpp
    )

add_executable( testamarok ${testamarok_SRCS} )
add_test(NAME testamarok COMMAND $<TARGET_FILE:testamarok>)
ecm_mark_as_test(testamarok)

target_link_libraries( testamarok
    KF${KF_MAJOR_VERSION}::KIOCore
    Qt::Test
    amarokcore
    amaroklib
    )

#------------------------ Test Debug -----------------------------

add_definitions(-DDEBUG_OVERRIDE_ELAPSED_TIME=4.9)
set( testdebug_SRCS
     TestDebug.cpp
     ${AMAROK_SOURCE_TREE}/core/support/Debug.cpp
     )

add_executable( testdebug ${testdebug_SRCS} )
add_test(NAME testdebug COMMAND $<TARGET_FILE:testdebug>)
ecm_mark_as_test(testdebug)
target_link_libraries(testdebug Qt::Test amarokcore )

#------------------------ Test EngineController -----------------------------

set( testenginecontroller_SRCS TestEngineController.cpp )
add_executable( testenginecontroller ${testenginecontroller_SRCS} )
add_test(NAME testenginecontroller COMMAND $<TARGET_FILE:testenginecontroller>)
ecm_mark_as_test(testenginecontroller)
target_link_libraries( testenginecontroller KF${KF_MAJOR_VERSION}::ThreadWeaver Qt::Test amaroklib amarokcore )

#------------------------ Test Expression -----------------------------

set( testexpression_SRCS
        TestExpression.cpp
        ${AMAROK_SOURCE_TREE}/core-impl/collections/support/Expression.cpp
    )

add_executable( testexpression  ${testexpression_SRCS} )
add_test(NAME testexpression COMMAND $<TARGET_FILE:testexpression>)
ecm_mark_as_test(testexpression)

target_link_libraries(testexpression Qt::Test)

#------------------------ Test QStringx -----------------------------

set( testqstringx_SRCS
        TestQStringx.cpp
        ${AMAROK_SOURCE_TREE}/QStringx.cpp
    )

add_executable( testqstringx  ${testqstringx_SRCS} )
add_test(NAME testqstringx COMMAND $<TARGET_FILE:testqstringx>)
ecm_mark_as_test(testqstringx)

target_link_libraries(testqstringx Qt::Test)

#------------------------ Test TagGuesser -----------------------------

set( testtagguesser_SRCS
        TestTagGuesser.cpp
        ${CMAKE_SOURCE_DIR}/shared/TagsFromFileNameGuesser.cpp
        ${AMAROK_SOURCE_TREE}/dialogs/TagGuesser.cpp
    )

add_executable( testtagguesser  ${testtagguesser_SRCS} )
add_test(NAME testtagguesser COMMAND $<TARGET_FILE:testtagguesser>)
ecm_mark_as_test(testtagguesser)

target_link_libraries(testtagguesser Qt::Test amarokcore)

#------------------------ Test TrackOrganizer -----------------------------

set( testtrackorganizer_SRCS
        TestTrackOrganizer.cpp
        ${AMAROK_SOURCE_TREE}/dialogs/TrackOrganizer.cpp
        ${AMAROK_SOURCE_TREE}/core/meta/Meta.cpp
        ${AMAROK_SOURCE_TREE}/QStringx.cpp
        ${GOOGLEMOCK_SRCS}
    )

add_executable( testtrackorganizer  ${testtrackorganizer_SRCS} )
add_test(NAME testtrackorganizer COMMAND $<TARGET_FILE:testtrackorganizer>)
ecm_mark_as_test(testtrackorganizer)

# Since Google recommends not to distribute a pre-compiled gtest library
# we have to build it our own
if(GOOGLEMOCK_GTEST_SOURCES)
    add_subdirectory( ${GOOGLEMOCK_GTEST_SOURCES} gtest )
    add_dependencies( testtrackorganizer gtest )
endif()

add_dependencies( testtrackorganizer amarokcore )
add_dependencies( testtrackorganizer amaroklib )

target_link_libraries( testtrackorganizer amarokcore amaroklib KF${KF_MAJOR_VERSION}::Solid Qt::Test Qt::Core Qt::Gui ${GOOGLEMOCK_LIBRARIES})

=== src/context/CMakeLists.txt ===
add_subdirectory( applets )


########### next target ###############

set( amarokpud_LIB_SRCS
    popupdropper/libpud/PopupDropper.cpp
    popupdropper/libpud/PopupDropperItem.cpp
    popupdropper/libpud/PopupDropperView.cpp
)

add_library( amarokpud SHARED ${amarokpud_LIB_SRCS} )

if(WIN32)
    target_compile_definitions(amarokpud PRIVATE MAKE_POPUPDROPPER_LIB)
endif()

target_include_directories( amarokpud PUBLIC
    ${CMAKE_CURRENT_SOURCE_DIR}/popupdropper/libpud
)

target_link_libraries(amarokpud Qt::Core Qt::Gui Qt::Svg Qt::SvgWidgets Qt::Widgets)

install( TARGETS amarokpud ${KDE_INSTALL_TARGETS_DEFAULT_ARGS} )


set(qml_plugin_qml_files
    qml_plugin/qmldir
    qml_plugin/Applet.qml
    qml_plugin/AppletHeader.qml
)

set(qml_plugin_SRCS
    qml_plugin/src/RatingItem.cpp
    qml_plugin/src/Plugin.cpp
    qml_plugin/src/PixmapItem.cpp
)

add_library(qml_plugin SHARED ${qml_plugin_SRCS})

target_link_libraries(qml_plugin
    amarokcore
    Qt::Quick
    KF${KF_MAJOR_VERSION}::WidgetsAddons
)

install( TARGETS qml_plugin DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/amarok/qml )

install( FILES ${qml_plugin_qml_files} DESTINATION ${KDE_INSTALL_QMLDIR}/org/kde/amarok/qml )

kpackage_install_package( context_qml_package org.kde.amarok.context genericqml )

=== src/services/CMakeLists.txt ===
include_directories( ${Amarok_SOURCE_DIR}/src )

add_subdirectory( magnatune )

# add_subdirectory( jamendo ) // Needs complete rewrite because of API change

if(OPENSSL_FOUND OR LIBGCRYPT_FOUND)
    if(LIBXML2_FOUND AND CURL_FOUND AND LOUDMOUTH_FOUND AND GLIB2_FOUND AND GOBJECT_FOUND AND QT5_GLIB_SUPPORT)
#        add_subdirectory( mp3tunes ) // Needs more work
    endif()
endif()

add_subdirectory( ampache )

if ( Mygpo-qt5_FOUND OR Mygpo-qt6_FOUND )
    add_subdirectory( gpodder )
endif()

if( LIBLASTFM_FOUND )
    add_subdirectory( lastfm )
endif()

add_subdirectory( opmldirectory )

=== supplementary_scripts/amarok_live/CMakeLists.txt ===
install(PROGRAMS amarok_live.py README amarok.live.remaster.part1.sh amarok.live.remaster.part2.sh DESTINATION ${KDE_INSTALL_DATADIR}/amarok/scripts/amarok_live)

=== tests/browsers/CMakeLists.txt ===
include_directories(
  ..
  ${AMAROK_SOURCE_TREE}
  ${CMAKE_BINARY_DIR}/src
  ${AMAROK_COLLECTION_SUPPORT_DIR}
)

include_directories(SYSTEM
  ${GOOGLEMOCK_INCLUDE_DIR}
  )

#------------------------ TestMasterSlaveSynchronizationJob -----------------------------

set( testsinglecollectiontreeitemmodel_SRCS
        TestSingleCollectionTreeItemModel.cpp
        ${GOOGLEMOCK_SRCS}
    )

add_executable( testsinglecollectiontreeitemmodel  ${testsinglecollectiontreeitemmodel_SRCS} )
add_test(NAME testsinglecollectiontreeitemmodel COMMAND $<TARGET_FILE:testsinglecollectiontreeitemmodel>)
ecm_mark_as_test(testsinglecollectiontreeitemmodel)

add_dependencies( testsinglecollectiontreeitemmodel amarokcore )
add_dependencies( testsinglecollectiontreeitemmodel amaroklib )

target_link_libraries(testsinglecollectiontreeitemmodel
                        amarokcore
                        amaroklib

                        Qt::Gui
                        KF${KF_MAJOR_VERSION}::ThreadWeaver
                        Qt::Test
                        Qt::Core
                        ${GOOGLEMOCK_LIBRARIES})

=== tests/core-impl/CMakeLists.txt ===
add_subdirectory( collections )
add_subdirectory( meta )
add_subdirectory( playlists )
add_subdirectory( support )

=== tests/core/CMakeLists.txt ===
add_subdirectory( capabilities )
add_subdirectory( collections )
add_subdirectory( interfaces )
add_subdirectory( logger )
add_subdirectory( meta )
add_subdirectory( playlists )

=== tests/dynamic/CMakeLists.txt ===
macro(link_database_test test_target)
    if(APPLE)
        set_target_properties(${test_target} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    endif()

    add_dependencies( ${test_target} amarokconfig_h )
    add_dependencies( ${test_target} amarokcore )
    add_dependencies( ${test_target} amaroklib)

    target_link_libraries(${test_target}
        amarokcore
        amaroklib
        KF${KF_MAJOR_VERSION}::KIOCore
        KF${KF_MAJOR_VERSION}::ThreadWeaver
        Qt::Test
        Qt::Core
        ${MYSQL_LIBRARIES}
        ${CMAKE_DL_LIBS}
#        ${TAGLIB_LIBRARIES}
    )

endmacro(link_database_test)


include_directories(
  ${AMAROK_TEST_TREE}
  ${AMAROK_SOURCE_TREE}
  # ${AMAROK_SOURCE_TREE}/core-impl/logger
  ${AMAROK_UTILITY_TREE}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_BINARY_DIR}/tests
  ${AMAROK_COLLECTION_SUPPORT_DIR}
)

include_directories(SYSTEM
  ${MYSQL_INCLUDE_DIR}
  )

#------------------------------- DynamicModel Test -------------------------------

set( dynamicmodel_SRCS
        TestDynamicModel.cpp
    )

add_executable( testdynamicmodel ${dynamicmodel_SRCS} )
add_test(NAME testdynamicmodel COMMAND $<TARGET_FILE:testdynamicmodel>)
ecm_mark_as_test(testdynamicmodel)
link_database_test( testdynamicmodel )

#------------------------------- TrackSet Test -------------------------------

set( trackset_SRCS
        TestTrackSet.cpp
    )

add_executable( testtrackset ${trackset_SRCS} )
add_test(NAME testtrackset COMMAND $<TARGET_FILE:testtrackset>)
ecm_mark_as_test(testtrackset)
link_database_test( testtrackset )

=== tests/playlist/CMakeLists.txt ===
include_directories(
  ${AMAROK_TEST_TREE}
  ${AMAROK_SOURCE_TREE}
  ${AMAROK_UTILITY_TREE}
  ${CMAKE_BINARY_DIR}/src
  ${CMAKE_BINARY_DIR}/tests
  ${AMAROK_COLLECTION_SUPPORT_DIR}
)

include_directories(SYSTEM
  ${GOOGLEMOCK_INCLUDE_DIR}
  )

#------------------------ Test CueFileSupport -----------------------------

set( testplaylistmodels_SRCS
        TestPlaylistModels.cpp
        ${AMAROK_SOURCE_TREE}/EngineController.cpp
        ${AMAROK_SOURCE_TREE}/browsers/CollectionSortFilterProxyModel.cpp
        ${AMAROK_SOURCE_TREE}/browsers/collectionbrowser/CollectionBrowserTreeView.cpp
        ${AMAROK_SOURCE_TREE}/browsers/collectionbrowser/CollectionWidget.cpp
        ${AMAROK_SOURCE_TREE}/browsers/CollectionTreeItemModel.cpp
        ${AMAROK_SOURCE_TREE}/browsers/CollectionTreeItemModelBase.cpp
        ${AMAROK_SOURCE_TREE}/browsers/CollectionTreeView.cpp
        ${AMAROK_SOURCE_TREE}/core/capabilities/BoundedPlaybackCapability.cpp
        ${AMAROK_SOURCE_TREE}/core/capabilities/MultiSourceCapability.cpp
        ${AMAROK_SOURCE_TREE}/core-impl/collections/support/TrashCollectionLocation.cpp
        ${AMAROK_SOURCE_TREE}/core-impl/collections/support/Expression.cpp
        ${AMAROK_SOURCE_TREE}/core-impl/collections/support/TextualQueryFilter.cpp
        ${AMAROK_SOURCE_TREE}/playback/PowerManager.cpp
        ${AMAROK_SOURCE_TREE}/playlist/PlaylistDefines.cpp
        ${AMAROK_SOURCE_TREE}/playlist/PlaylistModel.cpp
        ${AMAROK_SOURCE_TREE}/playlist/PlaylistModelStack.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/ProxyBase.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/GroupingProxy.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/SearchProxy.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/SortAlgorithms.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/SortFilterProxy.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/SortScheme.cpp
        ${AMAROK_SOURCE_TREE}/core-impl/playlists/types/file/PlaylistFileSupport.cpp
        ${AMAROK_SOURCE_TREE}/playlist/PlaylistItem.cpp
        ${AMAROK_SOURCE_TREE}/core/support/Amarok.cpp
        ${AMAROK_SOURCE_TREE}/scripting/scriptengine/AmarokCollectionViewScript.cpp
        ${AMAROK_SOURCE_TREE}/scripting/scriptengine/ScriptingDefines.cpp
        ${AMAROK_SOURCE_TREE}/widgets/PrettyTreeDelegate.cpp

        ${GOOGLEMOCK_SRCS}
)

add_executable( testplaylistmodels ${testplaylistmodels_SRCS} )
add_test(NAME testplaylistmodels COMMAND $<TARGET_FILE:testplaylistmodels>)
ecm_mark_as_test(testplaylistmodels)

add_dependencies( testplaylistmodels amaroklib )

target_link_libraries( testplaylistmodels
    amarokcore
    amaroklib
    KF${KF_MAJOR_VERSION}::KIOCore

    Qt::Test
    Qt::Core
    ${GOOGLEMOCK_LIBRARIES}
    ${CMAKE_DL_LIBS}
)

#------------------------ Test PlaylistLayout -----------------------------

set( testplaylistlayout_SRCS
        TestPlaylistLayout.cpp
        ${AMAROK_SOURCE_TREE}/playlist/layouts/LayoutManager.cpp
        ${AMAROK_SOURCE_TREE}/playlist/layouts/LayoutItemConfig.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/ProxyBase.cpp
        ${AMAROK_SOURCE_TREE}/playlist/proxymodels/GroupingProxy.cpp
        ${AMAROK_SOURCE_TREE}/playlist/PlaylistDefines.cpp
        ${AMAROK_SOURCE_TREE}/core-impl/playlists/types/file/PlaylistFileSupport.cpp
        ${AMAROK_SOURCE_TREE}/core/support/Amarok.cpp
        ${GOOGLEMOCK_SRCS}
)

add_executable( testplaylistlayout ${testplaylistlayout_SRCS} )
add_test(NAME testplaylistlayout COMMAND $<TARGET_FILE:testplaylistlayout>)
ecm_mark_as_test(testplaylistlayout)

add_dependencies( testplaylistlayout amaroklib )

target_link_libraries( testplaylistlayout
    amarokcore
    amaroklib
    KF${KF_MAJOR_VERSION}::KIOCore

    Qt::Test
    Qt::Core
    ${GOOGLEMOCK_LIBRARIES}
    ${CMAKE_DL_LIBS}
)

=== debian/changelog ===
amarok (3.3.1-2) unstable; urgency=medium

  [ Pino Toscano ]
  * Drop Rules-Requires-Root: no, no more needed since Debian trixie.
  * Properly use the kf6 dh addon when calling dh_auto_configure (as amarok
    is based on Qt 6 / KF6), rather than kf5.
  * Add the libcrypt-dev build dependency, as a couple of plugins link to it.
    (Closes: #1107026)
  * Tweak the descriptions a bit. (Closes: #1111872)
  * Switch the libqt5sql5-mysql, libqt5sql5-psql, and libqt5sql5-sqlite suggests
    to their Qt 6 counterparts, i.e. libqt6sql6-mysql, libqt6sql6-psql, and
    libqt6sql6-sqlite.
  * Update amarok.install according to the newer kpackage, which does not
    generate appstream metainfo files for packages anymore.
  * Since Amarok 3.3 Phonon is no more used, so:
    - drop the libphonon4qt6-dev, and libphonon4qt6experimental-dev build
      dependencies
    - drop the "Phonon Backend" section in README.Debian
    - drop phonon4qt5-backend in debian/bug-control
    - drop amarok.bug-presubj, which is practically entirely about Phonon

  [ Boyuan Yang ]
  * Drop build-dep on transitional pkg libtag1-dev again.

 -- Pino Toscano <pino@debian.org>  Fri, 10 Oct 2025 09:29:44 +0200

amarok (3.3.1-1) unstable; urgency=medium

  * Team upload.

  [ Aurélien COUDERC ]
  * New upstream release (3.3.1).
  * Build against Qt6, update build-deps and deps with the info from cmake.
  * Update the list of installed files.
  * Bump Standards-Version to 4.7.2, no change required.
  * Refresh patches.
  * Refresh lintian overrides.
  * Refresh copyright information.

 -- Aurélien COUDERC <coucouf@debian.org>  Wed, 13 Aug 2025 19:53:16 +0200

=== debian/control ===
Source: amarok
Section: sound
Priority: optional
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Pino Toscano <pino@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-exec,
               dh-sequence-kf6,
               cmake (>= 3.16~),
               extra-cmake-modules (>= 6.0.0~),
               gettext,
               libkirigami-dev,
               libavformat-dev (>= 4:0.5),
               libcrypt-dev,
               libgdk-pixbuf-2.0-dev,
               libglib2.0-dev,
               libgpod-dev (>= 0.7.0),
               libgstreamer-plugins-base1.0-dev,
               libgstreamer1.0-dev,
               libkf6archive-dev (>= 6.0.0~),
               libkf6codecs-dev (>= 6.0.0~),
               libkf6colorscheme-dev (>= 6.0.0~),
               libkf6config-dev (>= 6.0.0~),
               libkf6configwidgets-dev (>= 6.0.0~),
               libkf6coreaddons-dev (>= 6.0.0~),
               libkf6crash-dev (>= 6.0.0~),
               libkf6dbusaddons-dev (>= 6.0.0~),
               libkf6dnssd-dev (>= 6.0.0~),
               libkf6doctools-dev (>= 6.0.0~),
               libkf6globalaccel-dev (>= 6.0.0~),
               libkf6guiaddons-dev (>= 6.0.0~),
               libkf6i18n-dev (>= 6.0.0~),
               libkf6iconthemes-dev (>= 6.0.0~),
               libkf6kcmutils-dev (>= 6.0.0~),
               libkf6kio-dev (>= 6.0.0~),
               libkf6notifications-dev (>= 6.0.0~),
               libkf6package-dev (>= 6.0.0~),
               libkf6solid-dev (>= 6.0.0~),
               libkf6statusnotifieritem-dev (>= 6.0.0~),
               libkf6texteditor-dev (>= 6.0.0~),
               libkf6textwidgets-dev (>= 6.0.0~),
               libkf6threadweaver-dev (>= 6.0.0~),
               libkf6wallet-dev,
               libkf6widgetsaddons-dev (>= 6.0.0~),
               libkf6windowsystem-dev (>= 6.0.0~),
               liblastfm6-dev (>= 1.2.0~),
               libmariadb-dev,
               libmariadbd-dev,
               libmtp-dev (>= 1.0.0),
               libmygpo-qt6-dev (>= 1.2.0~),
               libofa0-dev,
               libtag-dev (>= 1.12~),
               pkgconf,
               python3:any,
               qt6-base-dev (>= 6.7.0~),
               qt6-declarative-dev (>= 6.7.0~),
               qt6-svg-dev (>= 6.7.0~),
               qt6-webengine-dev (>= 5.15.0~) [amd64 arm64 armhf i386],
               zlib1g-dev,
Build-Depends-Indep: mariadb-server-core,
Standards-Version: 4.7.2
Homepage: https://amarok.kde.org
Vcs-Git: https://salsa.debian.org/qt-kde-team/extras/amarok.git
Vcs-Browser: https://salsa.debian.org/qt-kde-team/extras/amarok

Package: amarok
Architecture: any
Depends: amarok-common (= ${source:Version}),
         amarok-utils (= ${binary:Version}),
         qml-module-org-kde-kirigami2 (>= 5.15.0~),
         qml-module-qtqml-models2 (>= 5.15.0~),
         qml-module-qtquick-controls2 (>= 5.15.0~),
         qml-module-qtquick-dialogs (>= 5.15.0~),
         qml-module-qtquick-layouts (>= 5.15.0~),
         qml-module-qtquick2 (>= 5.15.0~),
         qml-module-qtwebengine (>= 5.15.0~) [amd64 arm64 armhf i386],
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: kio-audiocd,
Suggests: amarok-doc (>= ${source:Version}),
          libqt6sql6-mysql,
          libqt6sql6-psql,
          libqt6sql6-sqlite,
          moodbar,
Description: easy to use media player based
 Amarok is a powerful music player with an intuitive interface. It makes
 playing the music you love and discovering new music easier than ever before
 and it looks good doing it! Amarok is based on the powerful Qt 6 / KDE
 Frameworks 6 and nicely integrates with KDE Plasma desktop.
 .
 Much work has been invested into integrating Amarok with various Web services:
   - Ampache
   - Jamendo Service
   - Last.fm
   - Librivox
   - MP3tunes
   - Magnatune
   - OPML Podcast Directory
 .
 Amarok comes with a lot of features including but not limited to:
   - Scripts - enhance your Amarok experience with community developed scripts.
   - Dynamic Playlists - create playlists that automatically update.
   - Context View - customize interface with the Plasma powered Context View.
   - PopUp Dropper - simplify drag&drop actions with revolutionary menu system.
   - Multiple Language Translations
   - Collection Management - organizing your music collection has never been
     easier with Amarok's powerful tagging, renaming, and sorting abilities.
   - Database Importing - import collections from Amarok 1.4 or iTunes.
   - Scriptable Services - integrate other web services into Amarok.

Package: amarok-common
Architecture: all
Depends: ${misc:Depends},
Recommends: amarok (>= ${source:Version}),
Description: architecture independent files for Amarok
 This package contains architecture independent files needed for Amarok to run
 properly. Therefore, unless you have 'amarok' package of the same version
 installed, you will hardly find this package useful.
 .
 Amarok is a powerful music player with an intuitive interface.

Package: amarok-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
Recommends: amarok (>= ${source:Version}),
            khelpcenter,
Description: Amarok documentation (Handbook)
 This package contains Amarok user documentation in various languages. It can be
 opened from the application menu Help -> Amarok Handbook.
 .
 Amarok is a powerful music player with an intuitive interface.

Package: amarok-utils
Section: utils
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: utilities for Amarok media player
 This package contains command line utilities that are typically used by Amarok
 media player but might also be useful on systems without Amarok installed.
 They are designed to be lightweight as they do not depend on KDE Frameworks.
 .
 Currently the package contains the following utilities:
   - amarokcollectionscanner - scans audio files, collects information from
     file tags and prints it in the structured XML format.
   - amarok_afttagger - a helper program which writes/removes custom tags
     to/from media files required for embedded "Amarok File Tracking".

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

override_dh_auto_configure:
	dh_auto_configure -Skf6 -- -DBUILD_TESTING=false

override_dh_bugfiles:
	dh_bugfiles -A

execute_after_dh_install-indep:
	# Copy errmsg.sys files from mariadb-server-core package
	debian/copy-errmsg-files.py /usr/share/mariadb debian/amarok-common/usr/share/amarok/mysqle

execute_after_dh_auto_install:
	# Remove development stuff
	find debian/tmp -name '*.so' -type l -print -delete

%:
	dh $@

.PHONY: override_dh_auto_test
